package com.example.checkboxhobbies2

import androidx.appcompat.app.AppCompatActivity
import android.os.Bundle
import android.widget.*
import androidx.core.view.children

class MainActivity : AppCompatActivity() {

    override fun onCreate(savedInstanceState: Bundle?) {
        super.onCreate(savedInstanceState)
        setContentView(R.layout.activity_main)

        //make code versions of layout widgets
        val btnEnter = findViewById<Button>(R.id.btnEnter)
        val tvHobbies = findViewById<TextView>(R.id.txtHobby)

        // there is an array of hobbies in res/values/strings.xml
        val hobbies = resources.getStringArray(R.array.hobbies)
        val cb_id_base:Int = 5000

        // there is a horizontal layout with children that are (initially empty) vertical linear layouts
        val ll_hobbies = findViewById<LinearLayout>(R.id.ll_hobby)
        val cols = ll_hobbies.children
        val col_num = ll_hobbies.childCount

        // loop over hobbies array add checkboxes to vertical linearLayout that are the
        // (three) columns in the horizontal (hobby) LinearLayout
        for (i in 0 until hobbies.size) {
            //Toast.makeText(this,item,Toast.LENGTH_SHORT).show()
            val cbHobby = CheckBox(this)  //instantiate a Checkbox
            cbHobby.setText(hobbies[i])                 //set the Text property
            cbHobby.id= cb_id_base+i
            val current_column = ll_hobbies.getChildAt(i%col_num) as LinearLayout
            current_column?.addView(cbHobby)          //add dynamic Checkbox
            cbHobby.setOnCheckedChangeListener(myCheckBoxListener)
        }

        //********************************************************************************************************
        //button click event
        btnEnter.setOnClickListener{
            //loop through checkboxes based on their layout assigned id (which is not their "real" id)
            // if checked add to hobby list string
            var hobbies = ""
            for (i in 0..17) {
                val resID = cb_id_base+i
                val myCheckBox = findViewById<CheckBox>(resID)

                if (myCheckBox.isChecked) {
                    hobbies += myCheckBox.text.toString() + " "
                }
            }//end loop over checkboxes
            if (hobbies == "") {
                tvHobbies.text = "Get a hobby"
            } else {
                tvHobbies.text = "Your hobbies are: $hobbies"
            }
        }//end btnEnter.setOnClickListener

    }//end onCreate

    //***************************************************************************************************************
    //checkbox checked change listener -- though we have to use CompoundButton
    var myCheckBoxListener: CompoundButton.OnCheckedChangeListener =
        CompoundButton.OnCheckedChangeListener { buttonView, isChecked ->
            //this textview is known to onCreate but we are outside of onCreate
            val tvHobbies = findViewById<TextView>(R.id.txtHobby)
            tvHobbies.text = "------"
        }//end myCheckBoxListener

}//end MainActivity class
